<template>
  <div class="detail-container">
    <BackToBall />
    <el-form
      ref="form1"
      :rules="rules"
      :model="model"
      :label-position="labelPosition"
      :label-width="labelWidth"
      @submit.prevent.native="onSubmit"
    >
      <el-form-item label="地區代號" prop="regionId">
        <el-select v-model="model.regionId" placeholder="請選擇地區代號">
          <el-option label="請選擇" value />
          <el-option label="台北" value="TP" />
          <el-option label="台中" value="tz" />
          <el-option label="台南" value="tn" />
          <el-option label="台東" value="td" />
        </el-select>
      </el-form-item>
      <el-form-item label="客戶代號" prop="custId" required>
        <el-input v-model="model.custId" clearable placeholder="客戶代號" />
      </el-form-item>
      <el-form-item label="身份證號" prop="personId">
        <el-input v-model="model.personId" placeholder="身份證號" />
      </el-form-item>
      <el-form-item label="本地名字" prop="locName">
        <el-input v-model="model.locName" clearable placeholder="請輸入本地名字" />
      </el-form-item>
      <el-form-item label="英文名字" prop="engName">
        <el-input v-model="model.engName" clearable placeholder="請輸入英文名字" />
      </el-form-item>
      <el-form-item label="客戶等級" prop="custLevel">
        <el-select v-model="model.custLevel" placeholder="請選擇客戶等級">
          <el-option label="Normal" value="1" />
          <el-option label="Middle" value="2" />
          <el-option label="VIP" value="3" />
        </el-select>
      </el-form-item>
      <el-form-item label="多選 checkbox">
        <el-checkbox checked>备选项1</el-checkbox>
        <el-checkbox checked>备选项2</el-checkbox>
      </el-form-item>
      <el-form-item label="多選1 radio">
        <el-radio-group v-model="radio">
          <el-radio :label="3">备选项3</el-radio>
          <el-radio :label="6">备选项6</el-radio>
          <el-radio :label="9">备选项9</el-radio>
        </el-radio-group>
      </el-form-item>

      <el-form-item label="計數器">
        <el-input-number v-model="num" :min="1" :max="10" label="描述文字" />
      </el-form-item>
      <el-form-item label="檔案上傳">
        <el-upload
          class="el-upload-container"
          action="https://jsonplaceholder.typicode.com/posts/"
          multiple
          :limit="3"
          :file-list="fileList"
        >
          <el-button size="small" type="primary">点击上传</el-button>
          <div slot="tip" class="el-upload__tip">只能上传jpg/png文件，且不超过500kb</div>
        </el-upload>
      </el-form-item>
      <el-form-item label="Datepicker">
        <el-date-picker
          v-model="date1"
          type="date"
          format="yyyy-MM-dd"
          value-format="yyyyMMdd"
          placeholder="选择日期"
        />
      </el-form-item>
      <el-form-item label="Date Range Picker">
        <el-date-picker
          v-model="date2"
          type="daterange"
          range-separator="至"
          start-placeholder="开始日期"
          end-placeholder="结束日期"
          format="yyyy-MM-dd"
          value-format="yyyyMMdd"
        />
      </el-form-item>
      <el-form-item label="Time Picker">
        <el-time-select v-model="date3" placeholder="选择时间" format="HH:mm:ss" />
      </el-form-item>
      <el-form-item label="Slider 滑块">
        <el-slider v-model="value1" :max="100" />
      </el-form-item>
      <el-form-item>
        <DetailToolPanel @submit="onSubmit" />
      </el-form-item>
    </el-form>
  </div>
</template>

<script>
import { rowData, setting, isReadonly, readonlyAll, doAction, isAdd, getLabelPosition } from '@/utils/common'
import entity from './scrips/detailEntity'
import { detailRules } from './scrips/rules'

export default {
  data() {
    const data = {
      model: (isAdd() ? entity : rowData()),
      rules: detailRules,
      radio: 9,
      num: 100,
      date1: '20191021',
      date2: ['20190101', '20191021'],
      date3: '1820',
      value1: 88,
      fileList: [{ name: 'food.jpeg', url: 'https://fuss10.elemecdn.com/3/63/4e7f3a15429bfda99bce42a18cdd1jpeg.jpeg?imageMogr2/thumbnail/360x360/format/webp/quality/100' }, { name: 'food2.jpeg', url: 'https://fuss10.elemecdn.com/3/63/4e7f3a15429bfda99bce42a18cdd1jpeg.jpeg?imageMogr2/thumbnail/360x360/format/webp/quality/100' }]
    }

    return Object.assign(data, setting)
  },
  computed: {
    labelPosition() {
      return getLabelPosition()
    }
  },
  mounted() {
    if (isReadonly()) {
      this.$nextTick(() => {
        readonlyAll(true)
      })
    }
  },
  methods: {
    onSubmit(action) {
      const url = '/basic/adjust/manager/detail/' + action
      this.$refs.form1.validate((valid) => {
        if (valid) {
          doAction(url, this.model).then(response => {
            // do something
          })
        } else {
          return false
        }
      })
    }
  }
}
</script>
